'===============================================================================
' Prime_Numbers.bas
' First release Nov 10, 2014 
' Latest revision November 28, 2016
'===============================================================================

#Include "GUI.bi"

Dim Shared As TextBox Text_n
Dim Shared As Button Button_Ok
Dim Shared As Listbox Table


Sub CreateWindow()
'Main window

	OpenWindow								(300, 500, "Search Prime Numbers")
	Var Label_n = Label_New		(10, 10, 160, 20, "Search from 0 to:")  
	Text_n = TextBox_New			(170, 10, 80, 20, "1000")
	Button_Ok = Button_New		(170, 40, 80, 20, "Ok")
	Table = ListBox_New				(10, 70, 240, 420)
		
End Sub


Function Prime(k As Integer) As Integer
	'Test if k is a prime number
    
  Dim As Integer i
  
  For i = 2 To Sqr(k)
		If k Mod i = 0 Then Return 0
  Next
  
  Return 1
    
End Function


Function LeftSet(s As String, Length As Integer) As String
	'Returns a string s left justified with length 'Length'
    
	Dim As String s0
 
	s0 = Space(Length)
	Lset s0, s
 
	Return s0
  
End Function


Sub Button_Ok_EventHandler()
'Calculate and diplay prime numbers

	Dim As Integer n, k, count
		
	n = Val(TextBox_GetText(Text_n))
	
	ListBox_Clear(Table)
	
	ListBox_Add(Table, LeftSet("Pos", 10) + LeftSet("Prime Number", 15))
	count = 0
	For k = 3 To n
		If Prime(k) = 1 Then
			count = count + 1
			ListBox_Add(Table, LeftSet(Str(count), 10) + LeftSet(Str(k), 15))
		End If
	Next
End Sub


'Main:

CreateWindow()

Do
	If TextBox_Event(Text_n) Then TextBox_Edit(Text_n)
	If Button_Event(Button_Ok) Then Button_Ok_EventHandler()
	ListBox_Event(Table)
  Sleep 1
Loop Until Window_Event_Close()

End	
