'===============================================================================
' Calculator.bas
' Jan 11, 2015
' Latest revision November 28, 2016
'===============================================================================

#Include "GUI.bi"

Dim Shared As TextBox Text_a, Text_b, Text_c
Dim Shared As Button Button_Plus, Button_Minus, Button_Mult, Button_Div
														

Sub CreateWindow_Main()
	'Hauptfenster
	
	OpenWindow									(300, 130, "Calculator")
	Var Label_a = Label_New			(20, 20, 80, 20, "Number 1:")
	Var Label_b = Label_New			(20, 50, 80, 20, "Number 2:")
	Var Label_c = Label_New			(20, 80, 80, 20, "Result:")
	Text_a = TextBox_New				(110, 20, 100, 20, "0")
	Text_b = TextBox_New				(110, 50, 100, 20, "0")
	Text_c = TextBox_New				(110, 80, 100, 20, "0", 1) 'ReadOnly
	Button_Plus = Button_New		(220, 20, 20, 20, "+")
	Button_Minus = Button_New		(260, 20, 20, 20, "-")
	Button_Mult = Button_New		(220, 50, 20, 20, "*")
	Button_Div = Button_New			(260, 50, 20, 20, "/")
	
End Sub


Sub Calc(RZ As String)
	'Get numbers a and b from textboxes, calculate and diplay result c
		
	Dim As Single a, b, c
	
	a = Val(TextBox_GetText(Text_a))
	b = Val(TextBox_GetText(Text_b))
	
	Select Case RZ
		Case "+"
			c = a + b
		Case "-"
			c = a - b
		Case "*"
			c = a * b
		Case "/"
			c = a / b
	End Select
	
	TextBox_SetText(Text_c, Str(c))
	
End Sub


'Main:

CreateWindow_Main()

Do
	If TextBox_Event(Text_a) Then TextBox_Edit(Text_a)
	If TextBox_Event(Text_b) Then TextBox_Edit(Text_b)
	If TextBox_Event(Text_c) Then TextBox_Edit(Text_c)
	If Button_Event(Button_Plus) Then Calc("+")
	If Button_Event(Button_Minus) Then Calc("-")
	If Button_Event(Button_Mult) Then Calc("*")
	If Button_Event(Button_Div) Then Calc("/")
  Sleep 1
Loop Until Window_Event_Close

End
