'===============================================================================
' GUI_Test_Trackbar.bas
' Vertical and horizontal trackbar
' Created on November 28, 2016
'===============================================================================

#Include "GUI.bi"

Dim As TrackBar TB_hor, TB_vert
Dim As TextBox Text_hor, Text_vert
Dim As Integer value

'GUI:
OpenWindow							(500, 400, "Test Trackbar, Range 200 ... 500")
TB_vert = TrackBar_New	(20, 20, 20, 300, 1)
Text_vert = TextBox_New	(50, 100, 60, 20, "", 1)
TB_hor = TrackBar_New		(20, 350, 300, 20)
Text_hor = TextBox_New	(330, 350, 60, 20, "", 1)

'Initialize all controls:
TrackBar_SetRange				(TB_hor, 200, 500)
TrackBar_SetRange				(TB_vert, 200, 500)
TrackBar_SetValue				(TB_hor, 300)
TrackBar_SetValue				(TB_vert, 300)
TextBox_SetText					(Text_hor, "300")
TextBox_SetText					(Text_vert, "300")

'Event loop:
Do
	Sleep 1
	If TrackBar_Event(TB_hor) Then
		value = TrackBar_GetValue(TB_hor)
		TextBox_SetText(Text_hor, Str(value))
	ElseIf TrackBar_Event(TB_vert) Then
		value = TrackBar_GetValue(TB_vert)
		TextBox_SetText(Text_vert, Str(value))
	End If
Loop Until Window_Event_Close()	

End
