'==============================================================================
' Paint.bas
' First release Feb 19, 2014
' Latest release November 28, 2016
'==============================================================================

#Include "GUI.bi"

'Color constants:
Const black = &H000000, blue = &H0000FF, green = &H00FF00, cyan = &H00FFFF, _
red = &HFF0000, magenta = &HFF00FF, yellow = &HFFFF00, grey = &HAAAAAA, _
white = &HFFFFFF

Dim As Button Btn_black, Btn_blue, Btn_green, Btn_cyan, Btn_red, Btn_magenta, _
						 	Btn_yellow, Btn_grey, Btn_erase, Btn_End
Dim As Integer MouseBtn, lastbutton, x, y, xleft, ytop, xright, ybottom
Dim As Uinteger colour

OpenWindow(640, 480, "Paint Program")

'Buttons marked with colors and close button:
Line (20, 20) - (40, 40), black, BF
Line (20, 40) - (40, 60), blue, BF
Line (20, 60) - (40, 80), green, BF
Line (20, 80) - (40, 100), cyan, BF
Line (20, 100) - (40, 120), red, BF
Line (20, 120) - (40, 140), magenta, BF
Line (20, 140) - (40, 160), yellow, BF
Line (20, 160) - (40, 180), grey, BF
Btn_black 	= Button_New(40,  20, 80, 20, "Black")
Btn_blue  	= Button_New(40,  40, 80, 20, "Blue")
Btn_green 	= Button_New(40,  60, 80, 20, "Green")
Btn_cyan  	= Button_New(40,  80, 80, 20, "Cyan")
Btn_red  		= Button_New(40, 100, 80, 20, "Red")
Btn_magenta = Button_New(40, 120, 80, 20, "Magenta")
Btn_yellow 	= Button_New(40, 140, 80, 20, "Yellow")
Btn_grey 		= Button_New(40, 160, 80, 20, "Grey")
Btn_erase		= Button_New(40, 200, 80, 20, "Delete")
Btn_End 		= Button_New(40, 240, 80, 20, "Close")

'Drawing region:
xleft = 140
ytop = 20
xright = 620
ybottom = 460
Line (xleft, ytop) - (xright, ybottom), white, BF

'Painting: see program from Zippy
'(http://www.freebasic.net/forum/viewtopic.php?f=2&t=22249)

Color(black, white)
lastbutton = 0

Do

	If Button_Event(Btn_black) Then colour = black
	If Button_Event(Btn_blue) Then colour = blue
	If Button_Event(Btn_green) Then colour = green
	If Button_Event(Btn_cyan) Then colour = cyan 
	If Button_Event(Btn_red) Then colour = red
	If Button_Event(Btn_magenta) Then colour = magenta
	If Button_Event(Btn_yellow) Then colour = yellow
	If Button_Event(Btn_grey) Then colour = grey
	If Button_Event(Btn_erase) Then colour = white
		
	GetMouse(x, y,,MouseBtn)
	If x > xleft And y > ytop And x < xright And y < ybottom Then
		If MouseBtn = 1 Then
			If lastbutton = 1 Then
				If colour <> white Then Line -(x, y), colour Else Circle (x, y), 3, white,,,,F 
			Else
				PSet(x, y)
				lastbutton = 1
			End If
		Else
			lastbutton = 0
		End If
  End If
  
	Sleep 10
	
Loop Until Button_Event(Btn_End) Or Window_Event_Close()

End

